﻿using UnityEngine;
using System.Collections;

public class ObjectiveMove : MonoBehaviour {
    public Transform target;
    public Vector2 moveTo;
    public float speed;
    public bool onlyOnce = false;

    private bool triggered = false;
    private bool noMore = false;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	}

    void FixedUpdate()
    {
        if (triggered == true)
        {
            Vector2 diff = moveTo - (Vector2)target.localPosition;
            Vector2 move = new Vector2();
            if (diff.x > 0)
            {
                move.x = Mathf.Min(diff.x, speed);
            }
            else if (diff.x < 0)
            {
                move.x = Mathf.Max(diff.x, -speed);
            }
            if (diff.y > 0)
            {
                move.y = Mathf.Min(diff.y, speed);
            }
            else if (diff.y < 0)
            {
                move.y = Mathf.Max(diff.y, -speed);
            }

            target.localPosition = target.localPosition + (Vector3)move;

            if ((Vector2)target.localPosition == moveTo)
            {
                triggered = false;
            }
        }
    }

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.tag == "Player")
        {
            if (noMore == false)
            {
                triggered = true;
                if (onlyOnce == true)
                {
                    noMore = true;
                }
            }
        }
    }
}
