﻿using UnityEngine;
using System.Collections;

public class ZoomCamera : MonoBehaviour {
    public Transform player;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
        if (Input.GetAxis("Zoom") > 0)
        {
            camera.enabled = true;
        }
        else
        {
            camera.enabled = false;
        }

        Vector3 pos = Camera.main.WorldToScreenPoint(player.position);
        //Debug.Log(pos.x + " " + pos.y);
        pos.x = pos.x / Camera.main.pixelWidth;
        pos.y = pos.y / Camera.main.pixelHeight;
        //Debug.Log(pos.x + " " + pos.y);

        Rect newRect = new Rect(pos.x - 0.2f, pos.y - 0.2f, 0.4f, 0.4f);
        newRect.x = Mathf.Clamp(newRect.x, 0, 0.6f);
        newRect.y = Mathf.Clamp(newRect.y, 0, 0.6f);

        camera.rect = newRect;
    }
}
